;
(function(w){

/*=====================================================================================*/
    var title$ = null;
    var body$ = null;
    var image$ = null;
    var channel$ = null;

    function getText(el) {
        var content = "";
        for (var i = 0; i < el.length; i++) {
            content = content + el[i].innerText;
        }
        return content;
    }

    function getTitleText(el) {
        var content = "";
        if (el.length > 0) {
            content = el[0].innerText;
        }
        return content;
    }

   function getImage(selector) {
        var imgTags = image$(selector);
         LbDebug("patternImage: " + imgTags);
        if (imgTags.length > 0) {
            for (var i = 0; i < imgTags.length; i++) {
                var image = imgTags[i];
                if (!checkImageSize(image)) {
                    continue;
                }
                //微信公众号图片抓取
                if(isURL(image.getAttribute('data-src'))) {
                    return image.getAttribute('data-src');
                }
                //汽车之家图片抓取
                if(isURL(image.getAttribute('data-original'))) {
                    return image.getAttribute('data-original');
                }
                // 域名为feeds.cloud.huawei.com的网页图片存在data-src属性，则取data-src的值，避免懒加载
                if(document.domain == "feeds.cloud.huawei.com" && image.getAttribute('data-src')) {
                    return image.getAttribute('data-src');
                }
                return image.src;
            }
        }
        return "";
    }

    function isURL(str_url) {// 验证url
        if(str_url) {
            var strRegex = "^((https|http|ftp|rtsp|mms|file)?://)";
            var re = new RegExp(strRegex);
            return re.test(str_url);
        }
        return false;
    }

    function processSelector(pattern) {
        hwCssSelector(window);

        try { //across domain exception
            title$ = processSelectorImpl(pattern.titleIframe);
            body$ = processSelectorImpl(pattern.bodyIframe);
            image$ = processSelectorImpl(pattern.imageIframe);
            channel$ = processSelectorImpl(pattern.channelIframe);
        } catch (e) {
            title$ = Lb$;
            body$ = Lb$;
            image$ = Lb$;
            channel$ = Lb$;
        }
    }

    function processSelectorImpl(path) {
        if (path == null) {
            return Lb$;
        }

        if (path.length == 0) {
            return Lb$;
        }

        var selector = Lb$;
        for (var i = 0; i < path.length; i++) {
            var iframePath = path[i];
            var iframeArray = selector(iframePath);
            if (iframeArray.length == 0) {
                return Lb$;
            }

            var iframe = iframeArray[0];
            if ((iframe.contentWindow || iframe).Lb$ == null) {
                hwCssSelector((iframe.contentWindow || iframe));
            }
            selector = iframe.contentWindow.Lb$;
        }
        return selector;
    }

    function getTitle(t) {
        if (typeof t == "function") {
            return t();
        }
        return getTitleText(title$(t));
    }

    function processPattern(pattern) {
        processSelector(pattern);
        var title = getTitle(pattern.title);
        var body = "";
        var image = "";
        var channel =  getText(channel$(pattern.channel));

        if (pattern.image) {
            image = getImage(pattern.image);
        }
        if (pattern.body) {
            body = getText(body$(pattern.body));
            if (!image || image.trim().length == 0) {
                var patternImage = pattern.body + " img";
                var patternBodys = pattern.body.split(',');
                if (patternBodys.length > 0) {
                    patternImage = patternBodys[0] + " img";
                    for(var i=1; i<patternBodys.length; i++) {
                        patternImage = patternImage + "," + patternBodys[i] + " img"
                    }
                }
                LbDebug("pattern.body:" + pattern.body + ",patternImage: " + patternImage);
                image = getImage(patternImage);
            }
        }

        var r = {
            "title" : title,
            "body": body,
            "image": image,
            "channel": channel,
            "ignoreUrl": pattern.ignoreUrl
        }

        return r;
    }

    function visiable(elem) {
        return !!( elem.offsetWidth || elem.offsetHeight || elem.getClientRects().length );
    };

    function checkImageSize(img) {
        if (!visiable(img)) {
            return false;
        }

        var w = img.clientWidth;
        if (w <= 1) {
            w = img.style.width.replace("px", "");
        }
        var h = img.clientHeight;
        if (h <= 1) {
             h = img.style.height.replace("px", ""); ;
        }

        var imageWidth = Number(w);
        var imageHeight = Number(h);
        if (isNaN(imageWidth) || isNaN(imageHeight)) {
            return false;
        }
        if (w < 200 && h < 200) {
            return false;
        }
        if ((w / h > 2.9 || h / w > 2.9) && Math.min(w, h) < 200) {
            return false;
        }
        return true;
    }

    w.LbProcessPattern = processPattern;
})(window)
;