lb_main();

 function lb_main() {
    try {
        var nodes = document.body;
        return  lb_iterator(nodes);;
    } catch (e) {
        return "";
    }
 }


 function lb_iterator(node) {
    if (node == null) {
        return;
    }
    var splitTag = "^";
    node = node.childNodes || node;
    var text = '';
    for (var i = 0; i < node.length; i++) {
        if (node[i].tagName && node[i].tagName.toLowerCase() == 'script') {
            continue;
        }
        if (node[i].tagName && node[i].tagName.toLowerCase() == 'style') {
            continue;
        }
        if (node[i]) {
            if (getNodeStyleAttr(node[i],"display") == 'none' || getNodeStyleAttr(node[i],"opacity") == 0) {
                continue;
            }
        }
        if (node[i].nodeType != 3) {
            text += lb_iterator(node[i].childNodes);
        } else {
            if (node[i].nodeValue != null && node[i].nodeValue.length > 0) {
                var trimValue = lb_trimValue(node[i].nodeValue);
                var newValue = trimValue.replace(/\s*/g, "");
                if (newValue.length > 0) {
                    text += trimValue + splitTag;
                }
            }
        }
    }
    return text;
 };

 function getNodeStyleAttr(element, name) {
     while(element.nodeType!=1){
         if(element.parentNode==null){
             return null;
         }
         element = element.parentNode;
     }
     var computedStyle;
     try {
         computedStyle = document.defaultView.getComputedStyle(element, null);
     } catch (e) {
         computedStyle = element.currentStyle;
     }
     if (computedStyle == null) {
         return null;
     }
     if (name != "float") {
         return computedStyle[name];
     } else {
         return computedStyle["cssFloat"] || computedStyle["styleFloat"];
     }
 }

 function lb_trimValue(value){
     value = value.replace(/(^\s*)|(\s*$)/g, "");
     value = value.replace(/[\r\n]/g, "");
     return value.replace(/(^\s*)|(\s*$)/g, "");
 }

